﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace WindowsGame1.GameObjects
{
    class BackgroundTile : GameObject
    {
        private Point m_location = new Point(-1, -1);

        public Point Location
        {
            get { return m_location; }
            set
            {
                if (value != m_location)
                {
                    m_location = value;
                    this.BoundingBox = new Rectangle(m_location.X * 16, m_location.Y * 16, 16, 16);
                }
            }
        }
    }

    class FloorTile : BackgroundTile
    {
        public FloorTile()
        {
            this.Friction = 1.0f;
        }

        public float Friction { get; set; }
    }

    class SpikeTile : FloorTile
    {
    }
}
