﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Audio;

namespace WindowsGame1.GameObjects
{
    class PlayerDamageSweat : GameObject
    {
        public PlayerDamageSweat(Point p)
        {
            this.TextureName = "Player.Sweat.1";
            this.BoundingBox = new Rectangle(p.X - 5, p.Y - 5, 10, 10);
            this.TickPriority = TickPriority.Environmental;
        }

        private long AnimStartFrame = -1;
        private long TicksPerFrame = 5;
        private int MoveX = 0;
        private int MoveY = -1;

        internal override void Tick()
        {
            if (this.AnimStartFrame == -1)
                AnimStartFrame = this.GameLevel.CurrentTickNumber;

            this.BoundingBox = new Rectangle(this.BoundingBox.X + MoveX, this.BoundingBox.Y + MoveY, this.BoundingBox.Width, this.BoundingBox.Height);

            if (AnimStartFrame + (TicksPerFrame * 1) < this.GameLevel.CurrentTickNumber)
            {
                this.TextureName = "Player.Sweat.2";
            }
            if (AnimStartFrame + (TicksPerFrame * 2) < this.GameLevel.CurrentTickNumber)
            {
                this.GameLevel.GameObjects.Remove(this);
            }
        }

        internal override void Draw(Point point, SpriteBatch spriteBatch)
        {
            Texture2D tex = this.GameLevel.Textures[this.TextureName];
            Point cp = this.BoundingBox.Center;

            spriteBatch.Draw(tex, new Rectangle(cp.X - (tex.Width / 2) - point.X,
                cp.Y - (tex.Height / 2) - point.Y, tex.Width, tex.Height), Color.White);
        }
    }

}
