﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Audio;

namespace WindowsGame1.GameObjects.Powerups
{
    abstract class Powerup : GameObject
    {
        public Powerup()
        {
            this.Expires = false;
            this.TickPriority = TickPriority.Powerup;
        }

        public Point Location
        {
            get { return this.BoundingBox.Center; }
            set
            {
                this.BoundingBox = new Rectangle(value.X - this.BoundingBox.Width / 2, value.Y - this.BoundingBox.Height / 2,
                    this.BoundingBox.Width, this.BoundingBox.Height);
            }
        }

        public bool Expires { get; set; }
        private int TicksUntilExpiration = 60 * 6;

        internal override void Tick()
        {
            ApplyGravity();

            if (this.Expires)
            {
                TicksUntilExpiration--;
                if (TicksUntilExpiration <= 0)
                {
                    this.GameLevel.GameObjects.Remove(this);
                }
            }
        }

        public abstract void CollideWithPlayer(PlayerObject player);
    }
}
