﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Audio;

namespace WindowsGame1.GameObjects
{
    class SmallExplosion : GameObject
    {
        public SmallExplosion(Point p)
        {
            this.ExplosionPoint = p;
            this.BoundingBox = new Rectangle(p.X - 20, p.Y - 20, 40, 40);
            this.TickPriority = TickPriority.Environmental;
        }

        private Point ExplosionPoint;

        private long ExplosionStartTick = -1;
        private long FrameTickLength = 2;

        internal override void Tick()
        {
            if (ExplosionStartTick == -1)
            {
                ExplosionStartTick = this.GameLevel.CurrentTickNumber;
                this.TextureName = "Explosions.Explode.1";
            }
            else if (ExplosionStartTick + FrameTickLength > this.GameLevel.CurrentTickNumber)
            {
                this.TextureName = "Explosions.Explode.2";
            }
            else if (ExplosionStartTick + (FrameTickLength * 2) > this.GameLevel.CurrentTickNumber)
            {
                this.TextureName = "Explosions.Explode.3";
            }
            else if (ExplosionStartTick + (FrameTickLength * 3) > this.GameLevel.CurrentTickNumber)
            {
                this.TextureName = "Explosions.Explode.4";
            }
            else if (ExplosionStartTick + (FrameTickLength * 4) > this.GameLevel.CurrentTickNumber)
            {
                this.GameLevel.GameObjects.Remove(this);
            }
        }

        internal override void Draw(Point point, SpriteBatch spriteBatch)
        {
            if (this.TextureName != null)
            {
                Texture2D tex = this.GameLevel.Textures[this.TextureName];
                int ofsx = tex.Width / 2;
                int ofsy = tex.Height / 2;

                spriteBatch.Draw(tex, new Rectangle(ExplosionPoint.X - ofsx - point.X, ExplosionPoint.Y - ofsy - point.Y, tex.Width, tex.Height), Color.White);
            }
        }
    }
}
