﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace WindowsGame1
{
    public struct RectangleF
    {
        public float Height;
        public float Width;
        public float X;
        public float Y;

        public RectangleF(float x, float y, float width, float height)
        {
            this.X = x;
            this.Y = y;
            this.Width = width;
            this.Height = height;
        }

        public static bool operator !=(RectangleF a, RectangleF b)
        {
            return !(a == b);
        }

        public static bool operator ==(RectangleF a, RectangleF b)
        {
            return (a.X == b.X && a.Y == b.Y && a.Width == b.Width && a.Height == b.Height);
        }

        public float Bottom
        {
            get { return Math.Max(this.Y, this.Y + this.Height); }
        }

        public Vector2 Center
        {
            get { return new Vector2(this.X + this.Width / 2, this.Y + this.Height / 2); }
        }

        public static RectangleF Empty
        {
            get { return new RectangleF(0.0f, 0.0f, 0.0f, 0.0f); }
        }

        public bool IsEmpty
        {
            get { return (this == RectangleF.Empty); }
        }

        public float Left
        {
            get { return Math.Min(this.X, this.X + this.Width); }
        }

        public Vector2 Location
        {
            get { return new Vector2(this.X, this.Y); }
        }

        public float Right
        {
            get { return Math.Max(this.X, this.X + this.Width); }
        }

        public float Top
        {
            get { return Math.Min(this.Y, this.Y + this.Height); }
        }

        public void Translate(Vector2 translationVector)
        {
            this.X += translationVector.X;
            this.Y += translationVector.Y;
        }

        public Rectangle ToRectangle()
        {
            return new Rectangle(
                Convert.ToInt32(this.X),
                Convert.ToInt32(this.Y),
                Convert.ToInt32(this.Width),
                Convert.ToInt32(this.Height));
        }
    }
}
